# norootforbuild

%define name      ffmpeg
%define version   0.5
%define release   15
%define major     0
%define lib       libffmpeg
%define libname   %{lib}%{major}
%define majoravcodec     52
%define libavcodec       libavcodec
%define libnameavcodec   %{libavcodec}%{majoravcodec}
%define majoravdevice    52
%define libavdevice      libavdevice
%define libnameavdevice  %{libavdevice}%{majoravdevice}
%define majoravformat    52
%define libavformat      libavformat
%define libnameavformat  %{libavformat}%{majoravformat}
%define majoravutil      49
%define libavutil        libavutil
%define libnameavutil    %{libavutil}%{majoravutil}
%define majorpostproc    51
%define libpostproc      libpostproc
%define libnamepostproc  %{libpostproc}%{majorpostproc}
%define majorswscale     0
%define libswscale       libswscale
%define libnameswscale   %{libswscale}%{majorswscale}

Name:           %{name}
Version:        %{version}
Release:        21.13
License:        LGPL v2 or later and some code GPL v2 or later
Group:          Productivity/Multimedia/Video/Editors and Convertors
Summary:        Hyper fast MPEG1/MPEG4/H263/RV and AC3/MPEG audio encoder
Summary(de):    Hyperschneller MPEG1/MPEG4/H263/RV Und AC3/MPEG Audio-Encoder
URL:            http://ffmpeg.mplayerhq.hu

Source0:        ffmpeg-0.5.tar.bz2

Patch0:         ffmpeg_configure.diff
BuildRoot:      %{_tmppath}/%{name}-buildroot
Prefix:         %{_prefix}
Requires:       %{libnameavcodec} = %{version}-%{release}
Requires:       %{libnameavdevice} = %{version}-%{release}
Requires:       %{libnameavformat} = %{version}-%{release}
Requires:       %{libnameavutil} = %{version}-%{release}
Requires:       %{libnameswscale} = %{version}-%{release}
%if 0%{?suse_version} >= 930
BuildRequires:  libdca-devel
BuildRequires:  libdca0
%endif
BuildRequires:  yasm >= 0.7.1
%if 0%{?suse_version} >= 1010 || 0%{?centos_version} || 0%{?rhel_version} || 0%{?fedora_version}
BuildRequires:  libgsm
BuildRequires:  libgsm-devel
%endif
BuildRequires:  imlib2-devel
BuildRequires:  libmp3lame-devel
BuildRequires:  libogg-devel
BuildRequires:  libvorbis-devel
BuildRequires:  libtheora-devel >= 1.0.final
BuildRequires:  ncurses-devel
BuildRequires:  libjack-devel
BuildRequires:  alsa-devel
BuildRequires:  freetype2-devel
BuildRequires:  SDL-devel
BuildRequires:  slang-devel
%if 0%{?centos_version} || 0%{?rhel_version} || 0%{?fedora_version}
BuildRequires:  xorg-x11-proto-devel xorg-x11-xtrans-devel
%endif
%if 0%{?suse_version} >= 920
BuildRequires:  xorg-x11-devel
%endif
%if 0%{?suse_version} > 0 && 0%{?suse_version} < 920
BuildRequires:  XFree86-devel
%endif
BuildRequires:  zlib-devel
BuildRequires:  libfaad2 >= 2.7
BuildRequires:  libfaad-devel >= 2.7
BuildRequires:  libfaac-devel >= 1.28
BuildRequires:  libx264-devel
BuildRequires:  libxvidcore-devel
BuildRequires:  libmp4v2-devel
BuildRequires:  texinfo
BuildRequires:  libamrnb-devel
BuildRequires:  libamrwb-devel
#BuildRequires:  liba52-devel
BuildRequires:  libdc1394
BuildRequires:  libdc1394-devel
BuildRequires:  libspeex-devel
%if 0%{?suse_version} >= 1030
BuildRequires:  libschroedinger-devel >= 1.0.5
BuildRequires:  liboil-devel >= 0.3.15
BuildRequires:  libdirac-devel >= 1.0.0
%endif
#%if 0%{?suse_version} >= 1100
#BuildRequires:  libnut-devel
#%endif
%if 0%{?suse_version} > 1020
BuildRequires:  libdc1394_control12-devel
%endif
#BuildRequires:  G.729-devel
BuildRequires:  nvidia-vdpau-devel

%if 0%{?rhel_version} || 0%{?centos_version} || 0%{?fedora_version}
BuildRequires: texi2html
%endif

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

%description -l de
ffmpeg ist ein hyperschneller realtime Audio-/Video-Encoder, ein Streaming
Server und ein Audio und Video Dateikonverter.

Es kann von einer Standard-Video4Linux-Quelle grabben und in verschiedene
Dateiformate basierend auf einer DCT/motion compensation konvertiern.
Sound wird in einen MPEG audio layer 2 oder AC3 Stream geschrieben.

%package -n %{libname}
Group:          System/Libraries
Summary:        metapackage for ffmpeg shared libraries
Summary(de):    Metapaket für die ffmpeg Bibliotheken
Requires:       %{libnameavcodec} = %{version}-%{release}
Requires:       %{libnameavdevice} = %{version}-%{release}
Requires:       %{libnameavformat} = %{version}-%{release}
Requires:       %{libnameavutil} = %{version}-%{release}
Requires:       %{libnamepostproc} = %{version}-%{release}
Requires:       %{libnameswscale} = %{version}-%{release}

%description -n %{libname}
metapackage for ffmpeg shared libraries

%description -n %{libname} -l de
Metapaket für die ffmpeg Bibliotheken

%package -n %{libnameavcodec}
Group:          System/Libraries
Summary:        ffmpeg %{libavcodec}
Provides:       %{libavcodec} = %{version}-%{release}

%description -n %{libnameavcodec}
ffmpeg %{libavcodec} shared library

%description -n %{libnameavcodec} -l de
ffmpeg %{libavcodec} Bibliothek


%package -n %{libnameavdevice}
Group:          System/Libraries
Summary:        ffmpeg %{libavdevice}
Provides:       %{libavdevice} = %{version}-%{release}

%description -n %{libnameavdevice}
ffmpeg %{libavdevice} shared library

%description -n %{libnameavdevice} -l de
ffmpeg %{libavdevice} Bibliothek


%package -n %{libnameavformat}
Group:          System/Libraries
Summary:        ffmpeg %{libavformat}
Provides:       %{libavformat} = %{version}-%{release}

%description -n %{libnameavformat}
ffmpeg %{libavformat} shared library

%description -n %{libnameavformat} -l de
ffmpeg %{libavformat} Bibliothek


%package -n %{libnameavutil}
Group:          System/Libraries
Summary:        ffmpeg %{libavutil}
Provides:       %{libavutil} = %{version}-%{release}

%description -n %{libnameavutil}
ffmpeg %{libavutil} shared library

%description -n %{libnameavutil} -l de
ffmpeg %{libavutil} Bibliothek


%package -n %{libnamepostproc}
Group:          System/Libraries
Summary:        ffmpeg %{libpostproc}
Provides:       %{libpostproc} = %{version}-%{release}

%description -n %{libnamepostproc}
ffmpeg %{libpostproc} shared library

%description -n %{libnamepostproc} -l de
ffmpeg %{libpostproc} Bibliothek


%package -n %{libnameswscale}
Group:          System/Libraries
Summary:        ffmpeg %{libswscale}
Provides:       %{libswscale} = %{version}-%{release}

%description -n %{libnameswscale}
ffmpeg %{libswscale} shared library

%description -n %{libnameswscale} -l de
ffmpeg %{libswscale} Bibliothek


%package -n %{lib}-devel
Group:          Development/Libraries/C and C++
Summary:        Header files and static library for the ffmpeg library
Summary(de):    Header Dateien und statische Bibliotheken für die ffmpeg Bibliothek
Requires:       %{libname} = %{version}-%{release}
Requires:       libmp3lame-devel
Requires:       libogg-devel
Requires:       libvorbis-devel
Requires:       libtheora-devel >= 1.0.final
Requires:       alsa-devel
Requires:       slang-devel
Requires:       zlib-devel
Requires:       libfaad-devel
Requires:       libfaac-devel
Requires:       libxvidcore-devel
Requires:       libmp4v2-devel
Requires:       libx264-devel
Requires:       libamrnb-devel
Requires:       libamrwb-devel
#Requires:       liba52-devel
Requires:       libjack-devel
Requires:       libspeex-devel
%if 0%{?suse_version} > 930
Requires:       libdca-devel
%endif
%if 0%{?suse_version} >= 1010
Requires:       libgsm-devel
%endif
Requires:       libdc1394
Requires:       libdc1394-devel
%if 0%{?suse_version} >= 1030
Requires:       libschroedinger-devel >= 1.0.5
Requires:       liboil-devel >= 0.3.15
Requires:       libdirac0
Requires:       libdirac-devel >= 1.0.0
%endif
#%if 0%{?suse_version} >= 1100
#Requires:       libnut-devel
#%endif
%if 0%{?suse_version} > 1020
Requires:       libdc1394_control12-devel
%endif
Requires:       nvidia-vdpau-devel
Provides:       %{libname}-devel = %{version}-%{release}
%ifarch x86_64 amd64 ia32e
Provides:       libavcodec.so()(64bit)
Provides:       libavformat.so()(64bit)
Provides:       libavutil.so()(64bit)
Provides:       libpostproc.so()(64bit)
%else
Provides:       libavcodec.so
Provides:       libavformat.so
Provides:       libavutil.so
Provides:       libpostproc.so
%endif
Obsoletes:      ffmpeg-devel
Provides:       ffmpeg-devel

%description -n %{lib}-devel
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg-devel if you want to compile apps with ffmpeg support.

%description -n %{lib}-devel -l de
ffmpeg ist ein hyperschneller realtime Audio-/Video-Encoder, ein Streaming
Server und ein Audio und Video Dateikonverter.

Es kann von einer Standard-Video4Linux-Quelle grabben und in verschiedene
Dateiformate basierend auf einer DCT/motion compensation konvertiern.
Sound wird in einen MPEG audio layer 2 oder AC3 Stream geschrieben.

Installieren Sie libffmpeg-devel wenn Sie Anwendungen mit ffmpeg Support
compilieren wollen.

%debug_package

%prep
%setup -q -n %{name}-%{version}
%patch0

%if 0%{?suse_version}
%suse_update_libdir configure
%endif
#don't call ldconfig on install
#perl -pi -e 's/ldconfig \|\| true//' libavcodec/Makefile

%build
archflags=""
%ifarch x86_64 amd64 ia32e
  archflags=" -fPIC"
%endif
%ifarch %ix86
#  archflags=" -pipe -ffast-math -fomit-frame-pointer -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
  archflags=" -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
  sed -i -e "s/-fPIC -DPIC//g" libpostproc/Makefile
%endif

CFLAGS="$RPM_OPT_FLAGS $archflags"
%if 0%{?suse_version} >= 1010
CFLAGS="${CFLAGS} -I%{_includedir}/gsm"
%endif
export archflags
export CFLAGS

./configure --shlibdir=%{_libdir} --prefix=%{_prefix} --mandir=%{_mandir} \
%if 0%{?suse_version} == 910
            --enable-memalign-hack \
%endif
            --libdir=%{_libdir} --enable-shared --enable-libmp3lame \
            --enable-libvorbis --enable-libtheora --enable-libspeex --enable-libfaad \
            --enable-libfaac --enable-libxvid --enable-swscale \
            --enable-postproc --enable-gpl --enable-vhook --enable-x11grab \
%if 0%{?suse_version} >= 1030
            --enable-libschroedinger --enable-libdirac \
%endif
%if 0%{?suse_version} >= 1010
            --enable-libgsm \
%endif
%ifarch ppc
            --disable-altivec \
%endif
            --enable-libx264 --enable-libamr-nb --enable-libamr-wb \
            --enable-libdc1394 --enable-nonfree --enable-pthreads \
            --enable-vdpau
#--enable-libg729a --enable-liba52 --enable-libopenjpeg
#%if 0%{?suse_version} >= 1100
#            --enable-libnut \
#%endif
%{__make} %{?jobs:-j%{jobs}}

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}
%{__ln_s} libavformat libav
#%{__make} DESTDIR=%{buildroot} mandir=%{buildroot}%{_mandir} \
#   prefix=%{buildroot}%{_prefix} \
#   bindir=%{buildroot}%{_bindir} \
#   libdir=%{buildroot}%{_libdir} \
#   mandir=%{buildroot}%{_mandir} \
#   includedir=%{buildroot}%{_includedir} \
#   install
%__make DESTDIR=%{buildroot} install

%{__mkdir_p} %{buildroot}%{_includedir}/postproc
%{__install} -d %{buildroot}%{_libdir}/libavcodec
%{__rm} -rf doc/.svn
%{__rm} -f doc/Makefile
%{__install} -m 644 libavcodec/dvdata.h %{buildroot}%{_includedir}/libavcodec/
pushd %{buildroot}%{_libdir}/libavcodec && %{__ln_s} -f ../libavcodec.a && popd
echo "Dummy package with dependencies to the real libs" > libffmpeg0.txt

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%post -n %{libnameavcodec} -p /sbin/ldconfig
%postun -n %{libnameavcodec} -p /sbin/ldconfig

%post -n %{libnameavdevice} -p /sbin/ldconfig
%postun -n %{libnameavdevice} -p /sbin/ldconfig

%post -n %{libnameavformat} -p /sbin/ldconfig
%postun -n %{libnameavformat} -p /sbin/ldconfig

%post -n %{libnameavutil} -p /sbin/ldconfig
%postun -n %{libnameavutil} -p /sbin/ldconfig

%post -n %{libnamepostproc} -p /sbin/ldconfig
%postun -n %{libnamepostproc} -p /sbin/ldconfig

%post -n %{libnameswscale} -p /sbin/ldconfig
%postun -n %{libnameswscale} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc Changelog COPYING.* CREDITS INSTALL MAINTAINERS README doc
%{_bindir}/*
%{_libdir}/vhook
%{_mandir}/man1/*
%{_datadir}/ffmpeg

%files -n %{libname}
%defattr(-,root,root)
%doc libffmpeg0.txt

%files -n %{libnameavcodec}
%defattr(-,root,root)
%{_libdir}/%{libavcodec}.so.%{majoravcodec}*

%files -n %{libnameavdevice}
%defattr(-,root,root)
%{_libdir}/%{libavdevice}.so.%{majoravdevice}*

%files -n %{libnameavformat}
%defattr(-,root,root)
%{_libdir}/%{libavformat}.so.%{majoravformat}*

%files -n %{libnameavutil}
%defattr(-,root,root)
%{_libdir}/%{libavutil}.so.%{majoravutil}*

%files -n %{libnamepostproc}
%defattr(-,root,root)
%{_libdir}/%{libpostproc}.so.%{majorpostproc}*

%files -n %{libnameswscale}
%defattr(-,root,root)
%{_libdir}/%{libswscale}.so.%{majorswscale}*

%files -n %{lib}-devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/*.*a
%{_libdir}/libavcodec
%{_libdir}/pkgconfig/*.pc

%changelog
* Mon Jun 29 2009 Carsten Schoene <cs@linux-administrator.com> - 0.5-15
- import for SLE_11 build
